<!DOCTYPE html>

<html>
  <head>
    <title>Practical JavaScript</title>
  </head>

  <body>
    <h1>Todo List</h1>

    <div>
      <button onclick="handlers.toggleAll()">Toggle All</button>
    </div>

    <div>
      <button onclick="handlers.addTodo()">Add</button>
      <input id="addTodoInputText" type="text">
    </div>

    <div>
      <button onclick="handlers.changeTodo()">Change Todo</button>
      <input id="changeTodoPositionInput" type="number">
      <input id="changeTodoTextInput" type="text">
    </div>

    <div>
      <button onclick="handlers.toggleCompleted()">Toggle Completed</button>
      <input id="toggleCompletedPositionInput" type="number">
    </div>

    <ul>

    </ul>

    <script>
      var todoList = {
        todos: [],
        addTodo: function(todoText) {
          this.todos.push({
            todoText: todoText,
            completed: false
          });
        },
        changeTodo: function(position, todoText) {
          this.todos[position].todoText = todoText;
        },
        deleteTodo: function(position) {
          this.todos.splice(position, 1);
        },
        toggleCompleted: function(position) {
          var todo = this.todos[position];
          todo.completed = !todo.completed;
        },
        toggleAll: function() {
          var totalTodos = this.todos.length;
          completedTodos = 0;
          
          // Get number of completed todos
          this.todos.forEach(function(todo) {
            if (todo.completed === true) {
              completedTodos++;
            }
          });

          this.todos.forEach(function(todo) {
            // Case 1: If everything's true, make everything false
            if (completedTodos === totalTodos) {
              todo.completed = false;
            } else {  // Case 2: Otherwise, make everything true
              todo.completed = true;
            }
          });
        }
      };

      var handlers = {
        addTodo: function() {
          var addTodoInputText = document.getElementById('addTodoInputText');
          todoList.addTodo(addTodoInputText.value);
          addTodoInputText.value = '';
          view.displaysTodos();
        },
        changeTodo: function() {
          var changeTodoPositionInput = document.getElementById('changeTodoPositionInput');
          var changeTodoTextInput = document.getElementById('changeTodoTextInput');
          todoList.changeTodo(changeTodoPositionInput.valueAsNumber, changeTodoTextInput.value);
          changeTodoPositionInput.value = '';
          changeTodoTextInput.value = '';
          view.displaysTodos();
        },
        deleteTodo: function(position) {
          todoList.deleteTodo(position);
          view.displaysTodos();
        },
        toggleCompleted: function() {
          var toggleCompletedPositonInput = document.getElementById('toggleCompletedPositionInput');
          todoList.toggleCompleted(toggleCompletedPositonInput.valueAsNumber);
          toggleCompletedPositonInput.value = '';
          view.displaysTodos();
        },
        toggleAll: function() {
          todoList.toggleAll();
          view.displaysTodos();
        }
      };

      var view = {
        displaysTodos: function() {
          var todosUl = document.querySelector('ul');
          todosUl.innerHTML = '';

          todoList.todos.forEach(function(todo, position) {
            var todoLi = document.createElement('li');
            var todoTextWithCompletion = '';

            if (todo.completed === true) {
              todoTextWithCompletion = '(x) ' + todo.todoText;
            } else {
              todoTextWithCompletion = '( ) ' + todo.todoText;
            }

            todoLi.id = position;
            todoLi.textContent = todoTextWithCompletion;
            todoLi.appendChild(this.createDeleteButton());
            todosUl.appendChild(todoLi);
          }, this);
        },
        createDeleteButton: function() {
          var deleteButton = document.createElement('button');
          deleteButton.textContent = 'Delete';
          deleteButton.className = 'deleteButton';
          return deleteButton;
        },

        setUpEventListeners: function() {
          var todosUl = document.querySelector('ul');

          todosUl.addEventListener('click', function(event) {
            // Get the element that was clicked on
            var elementClicked = event.target;

            // Check if elementClicked is a delete button
            if (elementClicked.className === 'deleteButton') {
              handlers.deleteTodo(parseInt(elementClicked.parentNode.id));
            }
          });
        }
      };

      view.setUpEventListeners();

    </script>
  </body>
</html>